var InformacoesDeDocumentosFiscaisReferenciados_Controller = function(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService, Df11000_Lancamento_Service) {

    var widgetCabecalhoEntrada, CDFILIAL, NRLANCTONF, NRORG;
    
    this.requestError = error => {
        if(error && error.data) {
            if(typeof(error.data.error) === 'string') {
                ScreenService.showMessage(error.data.error, "ERROR");
            }
            else {
                console.error(error);
                MessageService.showMessageByCode('ERRO_GERAL');
            }
        }
        else {
            console.error(error);
            MessageService.showMessageByCode('ERRO_GERAL');
        }
    };
   
    this.setCabecalhoWidgetEntrada = function(widget) {
        widgetCabecalhoEntrada =  widget;
        
        if (widgetCabecalhoEntrada && widgetCabecalhoEntrada.currentRow){
            NRLANCTONF  = widgetCabecalhoEntrada.currentRow.NRLANCTONF;
            CDFILIAL    = widgetCabecalhoEntrada.currentRow.CDFILIAL;
            NRORG       = widgetCabecalhoEntrada.currentRow.NRORG;
        }
    };
    
    this.changeDataSourceFilter = function(widget){
        var dataSourceFilter = widget.dataSourceFilter;
        
        dataSourceFilter = [];
        
        dataSourceFilter.push({operator: "=", name: "P_CDFILIAL", value: CDFILIAL});
        dataSourceFilter.push({operator: "=", name: "P_NRLANCTONF", value:NRLANCTONF});
        
        widget.dataSourceFilter = dataSourceFilter;
        
        widget.reload();
    };
    
    this.adicionarDados = function(widget){
        var fieldnrseqdocfiscrefe = widget.getField("NRSEQDOCFISCREFE");
        var filter = [
            {operator: "=", name: "P_CDFILIAL", value: CDFILIAL}, 
            {operator: "=", name: "P_NRLANCTONF", value:NRLANCTONF}
        ];
        
        General.callRestEngine("df#/crud/infordf_referenciados_nrseqdocfiscrefe", "FilterData",filter).then((success) => {
            if(success.dataset.infordf_referenciados_nrseqdocfiscrefe[0]) {
                fieldnrseqdocfiscrefe.setValue(success.dataset.infordf_referenciados_nrseqdocfiscrefe[0].NRSEQDOCFISCREFE);
            }else{
                fieldnrseqdocfiscrefe.setValue("1");
            }
        });
        
        General.widgetNewRow(widget);
    };
    
    this.cancela = function(args){
        var widget = args.owner.widget;
        if(widget.name == 'informacaoNF'){
            widget.getField("CDCUF").validations = {required: false};
            widget.getField("DTEMISSAO").validations = {required: false};
            widget.getField("NRINSJUREMITDOC").validations = {required: false};
            widget.getField("CDMOD").validations = {required: false};
            widget.getField("CDSERIE").validations = {required: false};
            widget.getField("NRNF").validations = {required: false};
        }
        if(widget.name == 'informacaoNFP'){ 
            widget.getField("CDCUF").validations = {required: false};
            widget.getField("DTEMISSAO").validations = {required: false};
            widget.getField("NRINSJUREMITDOC").validations = {required: false};
            widget.getField("NRIE").validations = {required: false};
            widget.getField("CDMOD").validations = {required: false};
            widget.getField("CDSERIE").validations = {required: false};
            widget.getField("NRNF").validations = {required: false};
        }
        if(widget.name == 'informacaoCF'){ 
            widget.getField("CDMOD").validations = {required: false};
            widget.getField("NRNECF").validations = {required: false};
            widget.getField("NRNCOO").validations = {required: false};
        }
        General.backOrCancel(args);
    };
    
    this.save = function(widget){
        if(widget.isValid()) {
            widget.currentRow.CDFILIAL   = CDFILIAL;
            widget.currentRow.NRLANCTONF = NRLANCTONF;
            widget.currentRow.NRORG      = NRORG;
             
            Df11000_Lancamento_Service.getStatusNota(widget.currentRow).then(salvaNota => {
                if(salvaNota) {
                    if(widget.name == 'informacaodaNfe'){ 
                        widget.getField("IDTPDOCREFE").setValue('refNFe');
                    }
                    if(widget.name == 'informacaoNF'){ 
                        widget.getField("IDTPDOCREFE").setValue('refNF');
                    }
                    if(widget.name == 'informacaoNFP'){ 
                        widget.getField("IDTPDOCREFE").setValue('refNFP');
                        if(!widget.getField("NRIE").value()){
                            widget.getField("NRIE").setValue('ISENTO');
                        }
                    }
                    if(widget.name == 'informacaoCTe'){ 
                        widget.getField("IDTPDOCREFE").setValue('refCTe');
                    }
                    if(widget.name == 'informacaoCF'){ 
                        widget.getField("IDTPDOCREFE").setValue('refECF');
                    }
                    
                    General.saveCrud(widget);
                    
                    if(widget.name == 'informacaoNF'){
                        widget.getField("CDCUF").validations = {required: false};
                        widget.getField("DTEMISSAO").validations = {required: false};
                        widget.getField("NRINSJUREMITDOC").validations = {required: false};
                        widget.getField("CDMOD").validations = {required: false};
                        widget.getField("CDSERIE").validations = {required: false};
                        widget.getField("NRNF").validations = {required: false};
                    }
                    if(widget.name == 'informacaoNFP'){
                        widget.getField("CDCUF").validations = {required: false};
                        widget.getField("DTEMISSAO").validations = {required: false};
                        widget.getField("NRINSJUREMITDOC").validations = {required: false};
                        widget.getField("NRIE").validations = {required: false};
                        widget.getField("CDMOD").validations = {required: false};
                        widget.getField("CDSERIE").validations = {required: false};
                        widget.getField("NRNF").validations = {required: false};
                    }
                    if(widget.name == 'informacaoCF'){ 
                        widget.getField("CDMOD").validations = {required: false};
                        widget.getField("NRNECF").validations = {required: false};
                        widget.getField("NRNCOO").validations = {required: false};
                    }
                }
                else MessageService.showMessageByCode('BLOCK_NOTE');
            }, this.requestError);
        }
     };
     
    this.verificaField = function(widget){
        if(widget.name == 'informacaoNF'){ 
            var cdcuf = widget.getField("CDCUF");
            var dtemissao = widget.getField("DTEMISSAO");
            var nrinsjuremitdoc = widget.getField("NRINSJUREMITDOC");
            var cdmod = widget.getField("CDMOD");
            var cdserie = widget.getField("CDSERIE");
            var nrnf = widget.getField("NRNF");
            if(!cdcuf.value() && !dtemissao.value() && !nrinsjuremitdoc.value() &&  !cdmod.value() && !cdserie.value() && !nrnf.value()  ){
                cdcuf.validations = {required: false};
                dtemissao.validations = {required: false};
                nrinsjuremitdoc.validations = {required: false};
                cdmod.validations = {required: false};
                cdserie.validations = {required: false};
                nrnf.validations = {required: false};    
            }else{
                cdcuf.validations = {required: true};
                dtemissao.validations = {required: true};
                nrinsjuremitdoc.validations = {required: true};
                cdmod.validations = {required: true};
                cdserie.validations = {required: true};
                nrnf.validations = {required: true};  
            }
            
        }
        if(widget.name == 'informacaoNFP'){ 
            var cdcufNFP = widget.getField("CDCUF");
            var dtemissaoNFP = widget.getField("DTEMISSAO");
            var nrinsjuremitdocNFP = widget.getField("NRINSJUREMITDOC");
            var nrie = widget.getField("NRIE");
            var cdmodNFP = widget.getField("CDMOD");
            var cdserieNFP = widget.getField("CDSERIE");
            var nrnfNFP = widget.getField("NRNF");
            if(!cdcufNFP.value() && !dtemissaoNFP.value() && !nrinsjuremitdocNFP.value() && !nrie.value() && !cdmodNFP.value() && !cdserieNFP.value() && !nrnfNFP.value()  ){
                cdcufNFP.validations = {required: false};
                dtemissaoNFP.validations = {required: false};
                nrinsjuremitdocNFP.validations = {required: false};
                nrie.validations = {required: false};
                cdmodNFP.validations = {required: false};
                cdserieNFP.validations = {required: false};
                nrnfNFP.validations = {required: false};    
            }else{
                cdcufNFP.validations = {required: true};
                dtemissaoNFP.validations = {required: true};
                nrinsjuremitdocNFP.validations = {required: true};
                nrie.validations = {required: true};
                cdmodNFP.validations = {required: true};
                cdserieNFP.validations = {required: true};
                nrnfNFP.validations = {required: true};  
            }
        }
        if(widget.name == 'informacaoCF'){ 
            var cdmodCF = widget.getField("CDMOD");
            var nrnecf = widget.getField("NRNECF");
            var nrncoo = widget.getField("NRNCOO");
            if(!cdmodCF.value() && !nrnecf.value() && !nrncoo.value()){
                cdmodCF.validations = {required: false};
                nrnecf.validations = {required: false};
                nrncoo.validations = {required: false};
            }else{
                cdmodCF.validations = {required: true};
                nrnecf.validations = {required: true};
                nrncoo.validations = {required: true};    
            }
        }
    };
    
    this.validaCNPJ = function (field) {
        if (!field.value()) {
            return;
        }
        if (!General.validateCNPJ(field.value())) {
            MessageService.showMessageByCode('CNPJ_INVALIDO');
            field.setValue("");
        }
    };
    
    this.validaCPFCNPJ = function(field) {
        if (!field.value()) {
            return;
        }
        if(field.value().length > 11 && field.value().length < 14){
            ScreenService.showMessage('CNPJ/CPF Inválido!');
            field.setValue("");
        }else if(field.value().length < 11){
            ScreenService.showMessage('CNPJ/CPF Inválido!');
            field.setValue("");
        }else{
            var inscricao = General.inscricaoFormat(field.value());
            if(inscricao.valid){
                if(inscricao.value.length == 18){
                    inscricao.value = inscricao.value.replace(/\D/g,'');
                }else{
                    inscricao.value = inscricao.value.replace(/\D/g,'');    
                }
                field.setValue(inscricao.value);
            }else{
                if(inscricao.tipo.cod == 'J'){
                    inscricao.tipo.msg = 'CNPJ'+" \""+inscricao.value+"\" inválido!";
                    field.setValue("");
                } else if(inscricao.tipo.cod == 'F'){
                    inscricao.tipo.msg = 'CPF'+" \""+inscricao.value+"\" inválido!";
                    field.setValue("");
                }else if(inscricao.tipo.cod == 'I'){ 
                    inscricao.tipo.msg = inscricao.tipo.desc+" \""+inscricao.value+"\" inválida!";
                    field.setValue("");
                }     
                if(inscricao.tipo.msg) ScreenService.showMessage(inscricao.tipo.msg, "warning");
            }
        }
    };
    
    this.deleteInfoDocRef = (widget) => {
        Df11000_Lancamento_Service.getStatusNota({CDFILIAL, NRLANCTONF, NRORG}).then(salvaNota => {
            if(salvaNota) General.deleteCrud(widget);
            else          MessageService.showMessageByCode('BLOCK_NOTE');
         }, this.requestError);
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register('InformacoesDeDocumentosFiscaisReferenciados_Controller', InformacoesDeDocumentosFiscaisReferenciados_Controller);
});